{    Demonstration of two video cogs running together doing NTSC
     graphics.  The main tv cog, is running at a low resolution (40x32).

     The tv1 cog is the overlay COG, running at 160x96.

     Both cogs are doing hi-color (1 byte per pixel) display.

     One pin used for sync between the two cogs.  No cog sync at this time.

     To Do:  Massive code cleanup * parametric coding of startup stuff in SPIN.

     

}

CON
  ' Set up the processor clock in the standard way for 80MHz on HYDRA
  _CLKMODE = xtal1 + pll8x
  _XINFREQ = 10_000_000 + 0000

  HORIZONTAL_PIXELS = 40
  VERTICAL_PIXELS = 32

VAR
  byte          displayb[HORIZONTAL_PIXELS * VERTICAL_PIXELS]   'allocate display buffer in RAM
  byte          displayb1[160*96]

  long          params[5]
                '[0] counter value to be watched for between cogs  0
                '[1] low res bitmap screen memory                  4
                '[2] high res bitmap screen memory                 8
                '[3] screen sync [lock id]                        12
                '[4] horizontal sync                              16
                                  
  long          index             'temp offset for byte statement below

  long          i, j, k, l, m     'misc working vars

OBJ
  tv : "two-cog-overlay-01_TV"  'the TV driver
  overlay : "two-cog-overlay-overlay-01" ' the overlay COG
  
PUB start |  c, o, d, p

    params[1] := @displayb  'low resolution frame buffer
    params[2] := @displayb1   'high resolution overlay buffer

    params[3] := $ff

   'fill bitmap with valid pixels, before triggering display there is no Color Lookup
   'Table in the TV driver just yet.

  
    repeat index from 0 to (HORIZONTAL_PIXELS * VERTICAL_PIXELS) 
      byte [@displayb] [index] := @@clut[0]  'fill screen with black pixels

    repeat index from 0 to (160 * 96) 
      byte [@displayb1] [index] := 00 '@@clut[0]  ***Overlay needs to either be below black, or colored to work

    i := CNT + 1_000_000   'Sync cogs
        
    params[0] := i  'store count in HUB for both cogs to access
        
    tv.start(@params)  'start the low resolution cog
    overlay.start(@params)  'start the overlay high resolution cog


    'Draw some low resolution stuff, with colors on the background COG.

    repeat k from 3 to 7 
      repeat j from 3 to 10 
        plot (k, j, (8*13) + 2)
        plot (k + 5, j + 3, (8*10) + 2)
        plot (k, j + 8, (8*2) + 1)

    repeat k from 20 to 39 step 4
      repeat j from 20 to 25
        plot (k, j, j-20)
        plot (k+1, j, j-20)

    repeat k from 22 to 32 step 2
      repeat j from 3 to 9
        plot (k, j, 3)
        plot (k-5, j+4, 1)

    repeat k from 1 to 39
       plot(k, 30, k)

    
    repeat k from 12 to 60 'coupla lines to show vertical resolution
      repeat j from 8 to 100 step 5
        'ploto(k,j + (k/2), k)
        ploto(k,k+12, 4)
        ploto(k,k+16, 3)
        ploto(k,k+20, 1)
        ploto(k,k+24, 0)


    'dots at screen overlay border

    ploto(0,0, 3)
    ploto(0,95,3)
    ploto(159,95,3)
    ploto(159,0,3)

      
    'color overlays

    repeat k from 10 to 20
      repeat j from 5 to 15
        ploto(k,j,(8*13+1))
        ploto(k+10, j+20, (8*10))


    repeat k from 80 to 150
      repeat j from 30 to 70
        ploto(k, j, (6*8) + 1)
    

    repeat k from 0 to (5*3) step 3
      repeat j from 80 to 85
        repeat o from 0 to 1
          ploto(k+o, j, (k/3))

    'Draw screen border background COG

    repeat k from 0 to HORIZONTAL_PIXELS - 1
      plot (k, 0, 18)
      plot (k, VERTICAL_PIXELS -1, 18)

    repeat k from 0 to VERTICAL_PIXELS - 1
      plot (0, k, 18)
      plot (HORIZONTAL_PIXELS - 1, k, 18)

 'overlay.start(@params)

      

       
pub plot(x,y,c)
  'very simple dot plotter
  'one byte per pixel is sweet!

  'c := c & %0111 'uncomment for monochrome display only

  'keep things sane
  x := x // HORIZONTAL_PIXELS
  y := y // VERTICAL_PIXELS
    
  displayb[y*HORIZONTAL_PIXELS+x] := @@clut[c & %01111111]   '128 color CLUT


pub ploto(x,y,c)
  'very simple dot plotter
  'one byte per pixel is sweet!

  'c := c & %0111 'uncomment for monochrome display only

  'keep things sane
  x := x // 160
  y := y // 96
    
  displayb1[y*160+x] := @@clut[c & %01111111]   '128 color CLUT

DAT

'Two Color tables here.  This commented one has the lowest intensity of each
'possible hue mapped to the low intensity color instead of the lowest intensity
'color.  Some televisions do not play well with these when they occupy large areas
'of the screen.  I've not had any trouble with mixed colors that incorporate these
'however.  YMMV.

'color lookup table, upper 4 bits hue, lower 4 intensity and saturation
'mixed together.  I've got the high saturation colors mapped to their
'closest hue.  They are the last two entries.

'I am including these as they make life easy with the standard propeller colors
'
'Ideally, a high color display will have these mappings crafted for 8 bit color
'such that the graphics generate code can then just ask for a color, instead of
'doing the tedious dot plotting I'm doing here for demonstration / proof of technique

{
clut
clut0   byte  byte  $02, $03, $04, $05, $06, $07, $07, $07
clut1   byte  byte  $1a, $1a, $1b, $1c, $1d, $1e, $98, $af
clut2   byte  byte  $2a, $2a, $2b, $2c, $2d, $2e, $a8, $bf
clut3   byte  byte  $3a, $3a, $3b, $3c, $3d, $3e, $b8, $cf
clut4   byte  byte  $4a, $4a, $4b, $4c, $4d, $4e, $c8, $df
clut5   byte  byte  $5a, $5a, $5b, $5c, $5d, $5e, $d8, $ef
clut6   byte  byte  $6a, $6a, $6b, $6c, $6d, $6e, $e8, $ff
clut7   byte  byte  $7a, $7a, $7b, $7c, $7d, $7e, $f8, $0f
clut8   byte  byte  $8a, $8a, $8b, $8c, $8d, $8e, $08, $1f
clut9   byte  byte  $9a, $9a, $9b, $9c, $9d, $9e, $18, $2f
cluta   byte  byte  $aa, $aa, $ab, $ac, $ad, $ae, $28, $3f
clutb   byte  byte  $ba, $ba, $bb, $bc, $bd, $be, $38, $4f
clutc   byte  byte  $ca, $ca, $cb, $cc, $cd, $ce, $48, $5f
clutd   byte  byte  $da, $da, $db, $dc, $dd, $de, $58, $6f
clute   byte  byte  $ea, $ea, $eb, $ec, $ed, $ee, $68, $7f
clutf   byte  byte  $fa, $fa, $fb, $fc, $fd, $fe, $78, $8f}


'  Unmodified CLUT below --use at
'  your own risk!  This one includes the low intensity colors.

clut
clut0   byte  byte  $02, $03, $04, $05, $06, $07, $07, $07
clut1   byte  byte  $19, $1a, $1b, $1c, $1d, $1e, $98, $af
clut2   byte  byte  $29, $2a, $2b, $2c, $2d, $2e, $a8, $bf
clut3   byte  byte  $39, $3a, $3b, $3c, $3d, $3e, $b8, $cf
clut4   byte  byte  $49, $4a, $4b, $4c, $4d, $4e, $c8, $df
clut5   byte  byte  $59, $5a, $5b, $5c, $5d, $5e, $d8, $ef
clut6   byte  byte  $69, $6a, $6b, $6c, $6d, $6e, $e8, $ff
clut7   byte  byte  $79, $7a, $7b, $7c, $7d, $7e, $f8, $0f
clut8   byte  byte  $89, $8a, $8b, $8c, $8d, $8e, $08, $1f
clut9   byte  byte  $99, $9a, $9b, $9c, $9d, $9e, $18, $2f
cluta   byte  byte  $a9, $aa, $ab, $ac, $ad, $ae, $28, $3f
clutb   byte  byte  $b9, $ba, $bb, $bc, $bd, $be, $38, $4f
clutc   byte  byte  $c9, $ca, $cb, $cc, $cd, $ce, $48, $5f
clutd   byte  byte  $d9, $da, $db, $dc, $dd, $de, $58, $6f
clute   byte  byte  $e9, $ea, $eb, $ec, $ed, $ee, $68, $7f
clutf   byte  byte  $f9, $fa, $fb, $fc, $fd, $fe, $78, $8f