
{  Hi-color-raster-variable-resolution_TV.spin

   Doug Dingus  07/07   Rev 1.0   For HYDRA

  This is the olverlay cog.  It's got timing issues....

  Vertical is ok.  Horizontal pixel timing is just not.

  Attempting to shorten horizontal timing so match can be found.

  Written for HYDRA -- Doug Dingus   /   CardboardGuru.


}
CON
  ' Set up the processor clock in the standard way for 80MHz
  _CLKMODE = xtal1 + pll8x
  _XINFREQ = 10_000_000 + 0000

  
PUB start(tvpointer) | i, j, k

  cognew(@entry,tvpointer)
  

DAT                     org
entry                   jmp     #initialization         'Jump past the constants



CON  NTSC_color_frequency       =     3_579_545
DAT  NTSC_color_freq            long  NTSC_color_frequency


CON  NTSC_hsync_clocks          =               624
DAT  NTSC_hsync_VSCL              long  160368
DAT  NTSC_hsync_VSCL_1          long  160368-19
DAT  NTSC_control_signal_palette long  $00_00_02_8a
DAT  NTSC_hsync_pixels          long  %%11_0000_1_2222222_11


'***************************************************
'* Blank lines                                     *
'***************************************************
CON  NTSC_active_video_clocks   =     3008
DAT  NTSC_active_video_VSCL     long  NTSC_active_video_clocks



'***************************************************
'* User graphics lines                             *
'***************************************************
' The important lines at last.  You can edit CHOOSE_horizontal_pixels (40, 80, 160, 256, 320)
' You can also edit CHOOSE_vertical_pixel_height.  (0 - 1)  
CON CHOOSE_horizontal_pixels  =  160
CON CHOOSE_vertical_pixel_height = 2   '1++ for variable vertical pixel heights
DAT vpixel                      long    CHOOSE_vertical_pixel_height
CON CHOOSE_clocks_per_gfx_pixel = 2560 / CHOOSE_horizontal_pixels
CON CALC_bytes_per_line = CHOOSE_horizontal_pixels
CON CALC_waitvids = CHOOSE_horizontal_pixels / 4

'4 pixels per waitvid.  We send their colors each time, for one byte per color.

CON CALC_clocks_per_gfx_frame   =  CHOOSE_clocks_per_gfx_pixel*4



DAT CALC_user_data_VSCL         long  CHOOSE_clocks_per_gfx_pixel << 12 + CALC_clocks_per_gfx_frame


CON CALC_frames_per_gfx_line    = CHOOSE_horizontal_pixels/4

CON CALC_overscan = 448 

CON CHOOSE_horizontal_offset    = 00

CON CALC_backporch = 208 + CHOOSE_horizontal_offset    'this must be a multiple of the total
                                                       'pixel clock 16 clocks in this case.
                                                       'only important if one is artifacting
                                                       'for high-color.  Do what you want
                                                       'here that makes sense otherwise.
CON CALC_frontporch = (CALC_overscan - CALC_backporch)

CON CALC_blank_overlay_time  =  1048560   'sum of all time, not active video time  4080 clocks per line
                                          'VCSL = 257 / clock

DAT

'This is the overlay COG.  It's only gonna output active video lines, or nothing.  The main
'graphics COG does the sync, etc...


initialization           

                  'work with parameter block  (some parameters not used at this time)
                        mov     C, PAR
                        rdlong  B, C                   'grab counter value to wait for in B
                        add     C, #8                  'index to overlay display buffer address
                        rdlong  A, C                   'store it in A
                                                
                        mov     bmp, A                'store it elsewhere as A will be written to

                        waitcnt B, #0                    'sync cogs


                        ' VCFG: setup Video Configuration register and 3-bit tv DAC pins to output
                        movs    VCFG, #%0000_0111       ' VCFG'S = pinmask (pin31: 0000_0111 : pin24)
                        movd    VCFG, #2                ' VCFG'D = pingroup (grp. 3 i.e. pins 24-31)

                        movi    VCFG, #%0_10_111_000    ' baseband video on bottom nibble, 2-bit color, enable chroma on broadcast & baseband
                                                        ' %0_xx_x_x_x_xxx : Not used
                                                        ' %x_10_x_x_x_xxx : Composite video to top nibble, broadcast to bottom nibble
                                                        ' %x_xx_1_x_x_xxx : 4 color mode
                                                        ' %x_xx_x_1_x_xxx : Enable chroma on broadcast
                                                        ' %x_xx_x_x_1_xxx : Enable chroma on baseband
                                                        ' %x_xx_x_x_x_000 : Broadcast Aural FM bits (don't care)

                        or      DIRA, tvport_mask       ' set DAC pins to output

                        ' 
                        'or      DIRA, #1                ' enable debug LED
                        'mov     OUTA, #1                ' light up debug LED

                        ' CTRA: setup Frequency to Drive Video
                        movi    CTRA,#%00001_111        ' pll internal routed to Video, PHSx+=FRQx (mode 1) + pll(16x)
                        mov     r1, NTSC_color_freq     ' r1: Color frequency in Hz (3.579_545MHz)
                        rdlong  v_clkfreq, #0           ' copy clk frequency. (80Mhz)
                        mov     r2, v_clkfreq           ' r2: CLKFREQ (80MHz)
                        call    #dividefract            ' perform r3 = 2^32 * r1 / r2
                        mov     v_freq, r3              ' v_freq now contains frqa.       (191)
                        mov     FRQA, r3                ' set frequency for counter

'Sync area.  Setup frame start, keyed to other cog.


sync_loop

                        'setup line counters for user graphics area
                        mov     line_loop, #192         
                        mov     vpixel_cnt, vpixel

                        mov    VSCL, #20  'must be some multiple of pixel timing... 


one_state               mov   D, INA        'look for 1 state
                        and   D, #1  
                        cmp   D, #1  wz
                if_nz   jmp   #one_state    ' zero?  Keep looking...

zero_state              mov   D, INA        'found it!
                        and   D, #1
                        cmp   D, #1  wz
                if_z   jmp   #zero_state    'now look for the zero again

              'output blank scanline, with timing adjustment to sync up pixels horizontally

                        mov     VSCL, NTSC_hsync_VSCL_1
                        waitvid NTSC_control_signal_palette, hsync

                        mov     VSCL, NTSC_active_video_VSCL
                        waitvid brown_border_in_color0, #0

                        


frame_loop              mov     line_loop, #192         
                        mov     vpixel_cnt, vpixel


                                               
user_graphics_lines



                        mov     VSCL, NTSC_hsync_VSCL 
                        waitvid NTSC_control_signal_palette, hsync
                        

first_line_skip         mov     VSCL,#CALC_backporch
                        waitvid green_border_in_color0, #0 
                        
                        'And now at long last, the user graphics.  Program the VSCL for
                        '  4 pixels per frame.  
                        mov     VSCL, CALC_user_data_VSCL


                        

                        'this is where the bitmap gets drawn.  We load a counter with the
                        'number of waitvids / line, and loop until they are done.

                        mov     r1, #CALC_waitvids  'number of horiz pixels / 4
:draw_pixels            rdlong  B, A    'get four pixels from hub

              
                        
                        waitvid B, #%%3210  'draw them to screen
                        movd    VCFG, #3
                        add     A, #4    'point to next pixel group
                        djnz    r1, #:draw_pixels  'line done?

                       

                        'We've finished drawing a user graphics line, whether it was color
                        '  bar or flag.  Now do the overscan bit.  
end_of_flag_line        mov    VSCL,#CALC_frontporch
                        waitvid blue_border_in_color0 , border
                        movd    VCFG, #2
                    
                        'deal with vertical pixel height
                        
                        sub     vpixel_cnt, #1  wz
               if_z     mov     vpixel_cnt, vpixel
               if_nz    sub     A, #CALC_bytes_per_line         

                        
                        'keep doing the 192 active display area
                        djnz    line_loop, #user_graphics_lines


                        'Reset raster display pointer for next frame
                        mov     A, bmp
'-----------------------------------------------------------------------------

'   So we eat up some lines of time...

                        

                         mov     line_loop, wait_scans           
:vsync_higha            mov     VSCL, NTSC_hsync_VSCL
                        waitvid NTSC_control_signal_palette, vsync_high_1
                        mov     VSCL, NTSC_active_video_VSCL
                        waitvid NTSC_control_signal_palette, vsync_high_2
                        djnz    line_loop, #:vsync_higha
'-------------------------------------------------------------------------------

                        jmp     #frame_loop






' /////////////////////////////////////////////////////////////////////////////
' dividefract:
' Perform 2^32 * r1/r2, result stored in r3 (useful for TV calc)
' This is taken from the tv driver.
' NOTE: It divides a bottom heavy fraction e.g. 1/2 and gives the result as a 32-bit fraction.
' /////////////////////////////////////////////////////////////////////////////
dividefract                                     
                        mov     r0,#32+1
:loop                   cmpsub  r1,r2           wc
                        rcl     r3,#1
                        shl     r1,#1
                        djnz    r0,#:loop

dividefract_ret         ret                             '+140


' General Purpose Registers (un initialized)
r0                      long                    $0    ' should typically equal 0
r1                      long                    $0
r2                      long                    $0
r3                      long                    $0

A                       long                    $0  'coupla more general purpose registers
B                       long                    $0
bmp                     long                    $0  'tvpointer ends up here
C                       long                    $0
vpixel_cnt              long                    $0  'counter for vertical pixel height
cnt_delay               long         10000
D                       long 0


'This is the scan line counter
line_loop               long    0


lockid                 long    0


wait_scans              long   70

' Video (TV) Registers
tvport_mask             long                    %0000_0111<<24

v_freq                  long                    0

' Graphics related vars.
v_coffset               long                    $02020202  ' color offset (every color is added by $02)
v_clkfreq               long                    $0




'Initialized data below here


'Pixel streams
'  These are shifted out of the VSU to the right, so lowest bits are actioned first.
'                               %%11_0000_1_2222222_11
hsync                   long    %%00_0000_0_0000000_00  ' Used with NTSC_control_signal_palette so:
                                                        '      0 = blanking level
                                                        '      1 = Black
                                                        '      2 = Color NTSC_control_signal_palette (yellow at zero value)
vsync_high_1            long    %%11111111111_222_11
vsync_high_2            long    %%1111111111111111
vsync_low_1             long    %%22222222222222_11
vsync_low_2             long    %%1_222222222222222
all_black               long    %%0000000000000000
border                  long    %%0000000000000000


'Palettes
'  These are always 4 colors (or blanking level) stored in reverse order:
'                               Color3_Color2_Color1_Color0

blue_border_in_color0   long    $00000000     'All set to grey
green_border_in_color0  long    $00000000     'Feel free to change these for interesting 
magenta_border_in_color0 long   $00000000     'border colors
brown_border_in_color0  long    $00000000



'Big Lookup table because I've got room right now for the CLUT.  Not implemented right now.
'CLUT being done in higher level program.  


clut   long $02020202    'Black = 00
       long $03030303
       long $04040404
       long $05050505
       long $06060606    'White = 100% IRE
       long $07070707
       long $07070707
       long $07070707    'Duped for lack of precision in DAC

       
       long $19191919    'Each of the 16 hues possible follows
       long $1a1a1a1a
       long $1b1b1b1b    'With the high-saturation colors mapped
       long $1c1c1c1c    'where they make sense
       long $1d1d1d1d
       long $1e1e1e1e
       long $98989898
       long $afafafaf

       
       long $29292929
       long $2a2a2a2a
       long $2b2b2b2b
       long $2c2c2c2c
       long $2d2d2d2d
       long $2e2e2e2e
       long $a8a8a8a8
       long $bfbfbfbf

       
       long $39393939
       long $3a3a3a3a
       long $3b3b3b3b
       long $3c3c3c3c
       long $3d3d3d3d
       long $3e3e3e3e
       long $b8b8b8b8
       long $cfcfcfcf

       
       long $49494949
       long $4a4a4a4a
       long $4b4b4b4b
       long $4c4c4c4c
       long $4d4d4d4d
       long $4e4e4e4e
       long $c8c8c8c8
       long $dfdfdfdf
       
       long $59595959
       long $5a5a5a5a
       long $5b5b5b5b
       long $5c5c5c5c
       long $5d5d5d5d
       long $5e5e5e5e
       long $d8d8d8d8
       long $efefefef
       
       long $69696969
       long $6a6a6a6a
       long $6b6b6b6b
       long $6c6c6c6c
       long $6d6d6d6d
       long $6e6e6e6e
       long $e8e8e8e8
       long $ffffffff

       long $79797979
       long $7a7a7a7a
       long $7b7b7b7b
       long $7c7c7c7c
       long $7d7d7d7d
       long $7e7e7e7e
       long $f8f8f8f8
       long $0f0f0f0f
       
       long $89898989
       long $8a8a8a8a
       long $8b8b8b8b
       long $8c8c8c8c
       long $8d8d8d8d
       long $8e8e8e8e
       long $08080808
       long $1f1f1f1f
       
       long $99999999
       long $9a9a9a9a
       long $9b9b9b9b
       long $9c9c9c9c
       long $9d9d9d9d
       long $9e9e9e9e
       long $18181818
       long $2f2f2f2f
       
       long $a9a9a9a9
       long $aaaaaaaa
       long $abababab
       long $acacacac
       long $adadadad
       long $aeaeaeae
       long $28282828
       long $3f3f3f3f

       long $b9b9b9b9
       long $babababa
       long $bbbbbbbb
       long $bcbcbcbc
       long $bdbdbdbd
       long $bebebebe
       long $38383838
       long $4f4f4f4f
       
       long $c9c9c9c9
       long $cacacaca
       long $cbcbcbcb
       long $cccccccc
       long $cdcdcdcd
       long $cececece
       long $48484848
       long $5f5f5f5f
       
       long $d9d9d9d9
       long $dadadada
       long $dbdbdbdb
       long $dcdcdcdc
       long $dddddddd
       long $dededede
       long $58585858
       long $6f6f6f6f
           
       long $e9e9e9e9
       long $eaeaeaea
       long $ebebebeb
       long $ecececec
       long $edededed
       long $eeeeeeee
       long $68686868
       long $7f7f7f7f
       
       long $f9f9f9f9
       long $fafafafa
       long $fbfbfbfb
       long $fcfcfcfc
       long $fdfdfdfd
       long $fefefefe
       long $78787878
       long $8f8f8f8f

                                   